/*
 IOI2001 
  


          
   25.    25   ,   
 Z.       25  .    
      5x5,   .   
ADJPTBEKQUCGLRVFINSWHMOXY   :
       A	D	J	P	T
       B	E	K	Q	U
       C	G	L	R	V
       F	I	N	S	W
       H	M	O	X	Y

   ,      ,    
           .  
 ADJPTBEKQUCGLRVFINSWHMOXY  ,   
ADJPTBEGQUCKLRVFINSWHMOXY   (       
     ). 

       ,    
 .         , 
  1. ,  ABCDEFGHIJKLMNOPQRSTUVWXY   1, 
 ABCDEFGHIJKLMNOPQRSUTVWXY -  2.   2  U  T    
   1.

 ,   .  ,    
    ,       .  
    2^31 .

 

   twofive.in      .     : 
W  N.     W,      , .. 25- . 
   N,       . 



   twofive.out      .       
 ,        .     
   ,           
.


 :

         
        .
      -    
       ,     .

           
  row[1..5]       
    .     , :

   row[i] >= row[i + 1]
   (i = 1 .. 4)

              
           
            
 .
            
       .

                
   ,        
 .    ,       
     .      
           
        .    
        -   
     .

        ?    
   .         .
      -  . .
        -   
    .     
          , 
        .

         ?      .
  ,         N- 
       .
           
          
      -    N.   N 
         (  ).
          
     .

  
*/
#include <fstream.h>
#include <string.h>

#define MAX_STATE 7776
#define SIZE 6

int calced[MAX_STATE];
int maxc[SIZE];
int maxr[SIZE];
int used[SIZE * SIZE];

struct state {
  int ar[SIZE];
};

int calcit(state c, int let)
{
  int i, stind, sum;

  for(stind = 0, i = 1; i <= 5; i++)
    stind = stind * 6 + c.ar[i];

  if(stind == MAX_STATE - 1)
    return 1;
    
  if(calced[stind])
    return calced[stind];

  if(used[let])
    return calced[stind] = calcit(c, let + 1);
  else
  {
    sum = 0;
    for(i = 1; i <= 5; i++)
      if(c.ar[i] < 5)
        if(i == 1 || c.ar[i] < c.ar[i - 1])
          if(let > maxr[i] && let > maxc[ c.ar[i] + 1 ])
          {
            c.ar[i]++;
            sum += calcit(c, let + 1);
            c.ar[i]--;
          }
  }

  return calced[stind] = sum;
}

void word2num(char *str)
{
  int i, r, c, let, ans;
  state st = {0};

  ans = 0;
  for(r = 1; r <= 5; r++)
    for(c = 1; c <= 5; c++)
    {
      let = str[(r - 1) * 5 + c - 1] - 64;
      st.ar[r]++;
      for(i = 1; i < let; i++)
        if(!used[i] && i > maxr[r] && i > maxc[c])
        {
          maxr[r] = maxc[c] = i;
          used[i] = 1;
          memset(calced, 0, sizeof(calced));
          ans += calcit(st, 1);
          used[i] = 0;
        }
      used[let] = 1;
      maxr[r] = maxc[c] = let;
    }
  cout << ans + 1 << endl;
}

void num2word(int num)
{
  int  i, r, c, let, aind;
  int  cnum, savnum;
  char ans[SIZE * SIZE];
  state st = {0};

  aind = 0;
  for(r = 1; r <= 5; r++)
    for(c = 1; c <= 5; c++)
    {
      st.ar[r]++;
      cnum = 0;
      for(i = 1; i <= 25; i++)
        if(!used[i] && i > maxr[r] && i > maxc[c])
        {
          maxr[r] = maxc[c] = i;
          used[i] = 1;
          savnum = cnum;
          memset(calced, 0, sizeof(calced));
          cnum += calcit(st, 1);
          if(cnum >= num) break;
          used[i] = 0;
        }
      num = num - savnum;
      ans[aind++] = char(i + 64);
    }
  ans[aind] = 0;
  cout << ans << endl;
}

void main()
{
  char command;
  char str[SIZE * SIZE];
  int  num;

  cin >> command;
  switch(command) {
    case 'W':
      cin >> str;
      word2num(str);
      break;
    case 'N':
      cin >> num;
      num2word(num);
      break;
  }
}
